/***********************************************************
*     a FREE MMC/SD-interface to SPI-slot of GD32VF103C    *
*                                                          *
*          by  Frank Goetze  -  www.embedded-os.de         *
************************************************************
* Permission to use, copy, modify, and distribute this     *
* software in source and binary forms and its              *
* documentation for any purpose and without fee is hereby  *
* granted, provided that the above authors notice appear   *
* in all copies and that both that authors notice and this *
* permission notice appear in supporting documentation.    *
*                                                          *
* THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND   *
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT    *
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY    *
* AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.     *
* IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT,  *
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR             *
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,    *
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF     *
* USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER *
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN        *
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE   *
* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY *
* OF SUCH DAMAGE.                                          *
************************************************************
*                      FFSPort_SPI.c                       *
*                 SPI-PORT DECLARATIONS                    *
***********************************************************/
#define MMC_GD32VF103C

#include "../../../../inc/OS_Def_GD32VF103.h"

#include "gd32vf103_rcu.h"
#include "gd32vf103_spi.h"
#include "gd32vf103_gpio.h"

/*
************************************************************
*                      DEFINITIONS
************************************************************
*/
#define SPIx     SPI1                                     // **** SPI1 ****
#define SPIx_bit GPIO_PIN_13 | GPIO_PIN_14 | GPIO_PIN_15  // -> on SPI1 its PB13, PB14, PB15
#define SPIx_Gx  GPIOB
#define CS_bit   GPIO_PIN_12                              // -> on SPI1 its PB12
#define CS_Gx    GPIOB

// no CD and WP pins available on SD slot on Longan Nano

#define FFSPort_MMC_CS_OFF    gpio_bit_set(CS_Gx, CS_bit)             // set CS high
#define FFSPort_MMC_CS_ON     gpio_bit_reset(CS_Gx, CS_bit)           // set CS low
#define FFSPort_MMC_CD()      0                                       // SD slot on Longan Nano - card-detect alltimes present
#define FFSPort_MMC_WP()      0                                       // SD slot on Longan Nano - default "not write protected"

/*
***********************************************************
*          MMC-Port of FFS/FAT FUNCTION PROTOTYPES
***********************************************************
*/
U32 FFSPort_MMC_SetBR(U32 maxclk);
U08 FFSPort_MMC_Send(U08 w);
U08 FFSPort_MMC_Init(void);
U08 FFSPort_MMC_ReInit(void);

/************************* END ****************************/
