/***********************************************************
*        a FREE MMC/SD-interface to SPI-slot of SAMD21     *
*                                                          *
*          by  Frank Goetze  -  www.embedded-os.de         *
************************************************************
* Permission to use, copy, modify, and distribute this     *
* software in source and binary forms and its              *
* documentation for any purpose and without fee is hereby  *
* granted, provided that the above authors notice appear   *
* in all copies and that both that authors notice and this *
* permission notice appear in supporting documentation.    *
*                                                          *
* THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND   *
* ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT    *
* LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY    *
* AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.     *
* IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT,  *
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR             *
* CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,    *
* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF     *
* USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER *
* CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN        *
* CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING           *
* NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE   *
* USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY *
* OF SUCH DAMAGE.                                          *
************************************************************
*                      FFSPort_SPI.c                       *
*                 SPI-PORT DECLARATIONS                    *
***********************************************************/
#define MMC_SAMD21

#include "../../../../inc/OS_Def_SAMD21.h"

/*
************************************************************
*                      DEFINITIONS
************************************************************
*/
#ifdef MMC_SAMD21
 #define MMC_SPI_NPCS0      PORT_PA18                      // /CS0 PIO-pin
 #define MMC_SPI_CD         PORT_PA07                      // CardDetect PIO-pin
 #define MMC_SPI_WP         0                              // WriteProtect not supported
 #define FFSPort_MMC_WP()   MMC_SPI_WP                     // no write-protect supported (microSD slot)
#else
 #error "unknown SAMD21 SPI-device!"
#endif
#define FFSPort_MMC_CS_OFF  PORT->Group[0].OUTSET.reg = MMC_SPI_NPCS0
#define FFSPort_MMC_CS_ON   PORT->Group[0].OUTCLR.reg = MMC_SPI_NPCS0

/*
***********************************************************
*          MMC-Port of FFS/FAT FUNCTION PROTOTYPES
***********************************************************
*/
U32 FFSPort_MMC_SetBR(U32 maxclk);
U08 FFSPort_MMC_Send(U08 w);
U08 FFSPort_MMC_Init(void);
U08 FFSPort_MMC_ReInit(void);
U08 FFSPort_MMC_CD(void);

/************************* END ****************************/

